<?php
//
// Chapter 10, pg. 261-262
//
class Cookie_UserInfo {
  public $name;
  public $userid;
  public $interests;
  public function __construct($user = false) {
    if($user) {
      $this->name = $user->name;
      $this->interests = $user->interests();
    }
    else {
      if(array_key_exists("USERINFO", $_COOKIE)) {
        list($this->name, $this->userid, $this->interests) =
          unserialize($_cookie['USERINFO']);
      }
      else {
        throw new AuthException("no cookie");
      }
    }
  }
  public function send() {
    $cookiestr = serialize(array($this->name, 
                               $this->userid, 
                               $this->interests));
    set_cookie("USERINFO", $cookiestr);
  }
}
class AuthException {
  public $message;
  public  function __construct($message = false) {
    if($message) {
      $this->message = $message;
    }
  }
}

?>
