<?php
//
// Chapter 12, pg 307-309
//
require_once "DB.inc";

class User {
  public $userid;
  public $username;
  public $firstname;
  public $lastname;
  public $salutation;
  public $countrycode;

  public static function findByUserid($userid)
  {
    return new User($userid);
  }

  public static function findByUsername($username)
  {
  }

  public function __construct($userid = false)
  {
    if(!$userid) {
      return;
    }
    $dbh = new DB_Mysql_Test;
    $query = "SELECT * from users WHERE userid = :1";
    $data = $dbh->prepare($query)->execute($userid)->fetch_assoc();
    foreach( $data as $attr => $value ) {
      $this->$attr = $value;
    }
  }

  public function update()
  {
    if(!$this->userid) {
      throw new Exception("User needs userid to call update()");
    }
    $query = "UPDATE users
              SET username = :1, firstname = :2, lastname = :3, 
                  salutation = :4, countrycode = :5
              WHERE userid = :6";
    $dbh = new DB_Mysql_Test;
    $dbh->prepare($query)->execute($this->username, $this->firstname, 
                                   $this->lastname, $this->salutation,
                                   $this->countrycode, $this->userid);
  }

  public function insert()
  {
    if($this->userid) {
      throw new Exception("User object has a userid, can't insert");
    }
    $query = "INSERT INTO users
                (username, firstname, lastname, salutation, countrycode)
                VALUES(:1, :2, :3, :4, :5)";
    $dbh = new DB_Mysql_Test;
    $dbh->prepare($query)->execute($this->username, $this->firstname, 
                                   $this->lastname, $this->salutation,
                                   $this->countrycode);
    list($this->userid) = 
      $dbh->prepare("select last_insert_id()")->execute()->fetch_row();
  }

  public function delete()
  {
    if(!$this->userid) {
      throw new Exception("User object has no userid");
    }
    $query = "DELETE FROM users WHERE userid = :1";
    $dbh = new DB_Mysql_Test;
    $dbh->prepare($query)->execute($this->userid);
  }
}

$user = User::findByUserid(2);
print_r($user);
$user->countrycode = 'de';
try {
$user->update();
$user2 = User::findByUserid(2);
print_r($user2);
}
catch (Exception $e) {
  print_r($e);
}



/* vim: set ts=2 sts=2 expandtab ai bs=2 : */
?>
