<?php
//
// Chapter 5, pg. 127-128
//
$counts = array('ip' => array(), 'user_agent' => array());
while(($line = fgets(STDIN)) != false) {
  // This regex matches a combined log format line field-by-field
  $regex = '/^(\S+) (\S+) (\S+) \[([^:]+):(\d+:\d+:\d+) ([^\]]+)\] '.
           '"(\S+) (.*?) (\S+)" (\S+) (\S+) "([^"]*)" "([^"]*)"$/';
  preg_match($regex,$line,$matches); 
  list(, $ip, $ident_name, $remote_user, $date, $time, 
       $gmt_off, $method, $url, $protocol, $code, 
       $bytes, $referrer, $user_agent) = $matches;
  $counts['ip']["$ip"]++;
  $counts['user_agent']["$user_agent"]++;
  if(($lineno++ % 1000) == 0) {
    fwrite(STDERR, ".");
  }
}
arsort($counts['ip'], SORT_NUMERIC);
reset($counts['ip']);
arsort($counts['user_agent'], SORT_NUMERIC);
reset($counts['user_agent']);


foreach(array('ip', 'user_agent') as $field) {
  $i = 0;
  print "Top number of requests by $field\n";
  print "--------------------------------\n";
  foreach($counts[$field] as $k => $v) {
    print "$v\t\t$k\n";
   if($i++ == 10) {
     break;
   }
  }
  print "\n\n";
}
?>
